zoukankan      html  css  js  c++  java
  • codeforces#302div2_C dp,二维完全背包

    codeforces#302div2_C dp,二维完全背包

    C. Writing Code
    time limit per test
    3 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    Programmers working on a large project have just received a task to write exactly m lines of code. There are n programmers working on a project, the i-th of them makes exactly ai bugs in every line of code that he writes.

    Let's call a sequence of non-negative integers v1, v2, ..., vn a plan, if v1 + v2 + ... + vn = m. The programmers follow the plan like that: in the beginning the first programmer writes the first v1 lines of the given task, then the second programmer writes v2 more lines of the given task, and so on. In the end, the last programmer writes the remaining lines of the code. Let's call a plan good, if all the written lines of the task contain at most b bugs in total.

    Your task is to determine how many distinct good plans are there. As the number of plans can be large, print the remainder of this number modulo given positive integer mod.

    Input

    The first line contains four integers nmbmod (1 ≤ n, m ≤ 500, 0 ≤ b ≤ 500; 1 ≤ mod ≤ 109 + 7) — the number of programmers, the number of lines of code in the task, the maximum total number of bugs respectively and the modulo you should use when printing the answer.

    The next line contains n space-separated integers a1, a2, ..., an (0 ≤ ai ≤ 500) — the number of bugs per line for each programmer.

    Output

    Print a single integer — the answer to the problem modulo mod.

    Sample test(s)
    input
    3 3 3 100
    1 1 1
    output
    10
    input
    3 6 5 1000000007
    1 2 3
    output
    0
    input
    3 5 6 11
    1 2 1
    output
    0

    题意:n个程序员,第i个程序员写每行代码会产生a[i]个bug,有m行代码的任务,要使产生的总bug<=m,求满足条件的方案总数,(每个程序员分担的代码为非负整数);
    思路:dp,这是一个完全背包问题,先写01背包版本,降维并改逆推为顺推即可变为完全背包:
          dp(i,j,k)=dp(i-1,j,k)+dp(i-1,j-1,k-a[i]) (k>=a[i])
        dp为用i个程序员写j行代码产生bug数为k(注意这里是等于k而不是小于k)的方案数,dp(0,0,0)=1;
        分两种情况:
          如果第i个程序员写了第j行代码,方案数为dp(i-1,j-1,k-a[i]);
          如果第i个程序员不写第j行代码,方案数为dp(i-1,j,k);
        由于每个程序员可以用无限次,显然是完全背包,降为二维数组顺推即可;
        答案为所有不超过bug的方案数总和;
    #include<iostream>
    #include<cstdio>
    #include<cstring>
    #include<cstdlib>
    #include<algorithm>
    
    using namespace std;
    
    const int maxn=3100;
    const int INF=(1<<29);
    
    int n,m,b,MOD;
    int a[maxn];
    int dp[maxn][maxn];
    
    int main()
    {
        while(cin>>n>>m>>b>>MOD){
            for(int i=1;i<=n;i++) scanf("%d",&a[i]);
            memset(dp,0,sizeof(dp));
            dp[0][0]=1;
            for(int i=1;i<=n;i++){
                for(int j=1;j<=m;j++){
                    for(int k=b;k>=a[i];k--){
                        dp[j][k]=(dp[j][k]+dp[j-1][k-a[i]]%MOD)%MOD;
                    }
                }
            }
            int ans=0;
            for(int i=0;i<=b;i++) ans=(ans%MOD+dp[m][i]%MOD)%MOD;
            cout<<ans%MOD<<endl;
        }
        return 0;
    }
    View Code
    没有AC不了的题,只有不努力的ACMER!
  • 相关阅读:
    Spring Boot中报错org.apache.ibatis.binding.BindingException: Parameter 'XXXX' not found. Available parameters are [0, 1, param1, param2]的解决办法
    CockroachDB学习笔记——[译]Cgo的成本与复杂性
    CockroachDB学习笔记——[译]如何优化Go语言中的垃圾回收
    解决Java中的HttpServletResponse中文乱码问题
    Spring Boot自定义Mapper的SQL语句
    Spring Boot设置定时任务
    Java8中List的removeif()函数的使用示例
    skip list跳跃表实现
    五分钟理解一致性哈希算法(consistent hashing)
    github 更新fork分支
  • 原文地址:https://www.cnblogs.com/--560/p/4502251.html
Copyright © 2011-2022 走看看